---
title: XRView
slug: Web/API/XRView
tags:
  - API
  - AR
  - Eye
  - Interface
  - Orientation
  - Position
  - Reference
  - VR
  - View
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRView
  - camera
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>'s <code><strong>XRView</strong></code> interface provides information describing a single view into the XR scene for a specific frame, providing orientation and position information for the viewpoint.</span> You can think of it as a description of a specific eye or camera and how it views the world. A 3D frame will involve two views, one for each eye, separated by an appropriate distance which approximates the distance between the viewer's eyes. This allows the two views, when projected in isolation into the appropriate eyes, to simulate a 3D world.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("XRView.eye", "eye")}} {{ReadOnlyInline}}</dt>
 <dd>Which of the two eyes (<code>left</code>) or (<code>right</code>) for which this <code>XRView</code> represents the perspective. This value is used to ensure that any content which is pre-rendered for presenting to a specific eye is distributed or positioned correctly. The value can also be <code>none</code> if the <code>XRView</code> is presenting monoscopic data (such as a 2D image, a full-screen view of text. or a close-up view of something that doesn't need to appear in 3D).</dd>
 <dt>{{domxref("XRView.projectionMatrix", "projectionMatrix")}} {{ReadOnlyInline}}</dt>
 <dd>The projection matrix that will transform the scene to appear correctly given the point-of-view indicated by <code>eye</code>. This matrix should be used directly in order to avoid presentation distortions that may lead to potentially serious user discomfort.</dd>
 <dt>{{domxref("XRView.transform", "transform")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("XRRigidTransform")}} which describes the current position and orientation of the viewpoint in relation to the {{domxref("XRReferenceSpace")}} specified when {{domxref("XRFrame.getViewerPose", "getViewerPose()")}} was called on the {{domxref("XRFrame")}} being rendered.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Positions_and_number_of_XRViews_per_frame">Positions and number of XRViews per frame</h3>

<p>While rendering a scene, the set of views that are used to render the scene for the viewer as of the current frame are obtained by calling the {{domxref("XRFrame")}} object's {{domxref("XRFrame.getViewerPose", "getViewerPose()")}}  method to get the {{domxref("XRViewerPose")}} representing (in essence) the position of the viewer's head. That object's {{domxref("XRViewerPose.views", "views")}} property is a list of all of the <code>XRView</code> objects representing the viewpoints which can be used to construct the scene for presentation to the user.</p>

<p>It's possible to have <code>XRView</code> objects which represent overlapping regions as well as entirely disparate regions; in a game, you might have views that can be presented to observe a remote site using a security camera or other device, for example. In other words, don't assume there are exactly two views on a given viewer; there can be as few as one (such as when rendering the scene in <code>inline</code> mode, and potentially many (especially if the field of view is very large). There might also be views representing observers watching the action, or other viewspoints not direclty associated with a player's eye.</p>

<p>In addition, the number of views can change at any time, depending on the needs of the time. So you should process the view list every time without making assumptions based on previous frames.</p>

<p>All positions and orientations within the views for a given {{domxref("XRViewerPose")}} are specified in the reference space that was passed to {{domxref("XRFrame.getViewerPose()")}}; this is called the <strong>viewer reference space</strong>. The {{domxref("XRView.transform", "transform")}} property describes the position and orientation of the eye or camera represented by the <code>XRView</code>, given in that reference space.</p>

<h3 id="The_destination_rendering_layer">The destination rendering layer</h3>

<p>To render a frame, you just iterate over the <code>XRViewerPose</code>'s views, rendering each of them into the appropriate viewport within the frame's {{domxref("XRWebGLLayer")}}. Currently, the specification (and therefore all current implementations of WebXR) is designed around rendering every <code>XRView</code> into a single <code>XRWebGLLayer</code>, which is then presented on the XR device with half used for the left eye and half for the right eye. The {{domxref("XRViewport")}} for each view is used to position the rendering into the correct half of the layer.</p>

<p>If in the future it becomes possible for each view to render into a different layer, there would have to be changes made to the API, so it's safe for now to assume that all views will render into the same layer.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Preparing_to_render_every_view_for_a_pose">Preparing to render every view for a pose</h3>

<p>To draw eerything the user sees each frame requires iterating over the list of views returned by the {{domxref("XRViewerPose")}} object's  {{domxref("XRViewerPose.views", "views")}} list:</p>

<pre class="brush: js">for (let view of pose.views) {
  let viewport = glLayer.getViewport(view);

  gl.viewport(viewport.x, viewport.y, viewport.width, viewport.height);

  // Draw the scene; the eye being drawn is identified
  // by view.eye.
}
</pre>

<h3 id="Special_view_transforms">Special view transforms</h3>

<p>There are a few special transforms that are used on the view while rendering and lighting a scene.</p>

<h4 id="Model_view_matrix">Model view matrix</h4>

<p>The <strong>model view matrix</strong> is a matrix which defines the position of an object relative to the space in which it's located: If <code>objectMatrix</code> is a transform applied to the object to provide its basic position and rotation, then the model view matrix can be computed by multiplying the object's matrix by the inverse of the view transform matrix, like this:</p>

<pre class="brush: js">mat4.multiply(modelViewMatrix, view.transform.inverse.matrix, objectMatrix);</pre>

<h4 id="Normal_matrix">Normal matrix</h4>

<p>The model view's <strong>normal matrix</strong> is used when lighting the scene, in order to transform each surface's normal vectors to ensure that the light is reflected in the correct direction given the orientation and position of the surface relative to the light source or sources. It's computed by inverting then transposing the model view matrix:</p>

<pre class="brush: js">mat4.invert(normalMatrix, modelViewMatrix);
mat4.transpose(normalMatrix, normalMatrix);
</pre>

<h3 id="Teleporting_an_object">Teleporting an object</h3>

<p>To programmatically move and/or rotate (often referred to as <strong>teleporting</strong>) an object, you need to create a new reference space for that object which applies a transform that encapsulates the desired changes. The <code>createTeleportTransform()</code> function returns the transform needed to move and rotate an object whose current situation is described by the reference space <code>refSpace</code> to a new position and orientation which is computed using previously recorded mouse and keyboard input data which has generated offsets for yaw, pitch, and position along all three axes.</p>

<pre class="brush: html">function applyMouseMovement(refSpace) {
  if (!mouseYaw &amp;&amp; !mousePitch &amp;&amp; !axialDistance &amp;&amp;
      !transverseDistance &amp;&amp; !verticalDistance) {
    return refSpace;
  }

  // Compute the quaternion used to rotate the image based
  // on the pitch and yaw.

  quat.identity(inverseOrientation);
  quat.rotateX(inverseOrientation, inverseOrientation, -mousePitch);
  quat.rotateY(inverseOrientation, inverseOrientation, -mouseYaw);

  // Compute the true "up" vector for our object.

  vec3.cross(vecX, vecY, cubeOrientation);
  vec3.cross(vecY, cubeOrientation, vecX);

  // Now compute the transform that teleports the object to the
  // specified point and save a copy of it to display to the user
  // later; otherwise we probably wouldn't need to save mouseMatrix
  // at all.

  let newTransform = new XRRigidTransform({x: transverseDistance,
                                           y: verticalDistance,
                                           z: axialDistance},
                         {x: inverseOrientation[0], y: inverseOrientation[1],
                          z: inverseOrientation[2], w: inverseOrientation[3]});
  mat4.copy(mouseMatrix, newTransform.matrix);

  // Create a new reference space that transforms the object to the new
  // position and orientation, returning the new reference space.

  return refSpace.getOffsetReferenceSpace(newTransform);
}</pre>

<p>This code is broken into four sections. In the first, the quaternion <code>inverseOrientation</code> is computed. This represents the rotation of the object given the values of <code>mousePitch</code> (rotation around the object's reference's space's X axis) and <code>mouseYaw</code> (rotation around the object's Y axis).</p>

<p>The second section computes the "up" vector for the object. This vector indicates the direction which is "up" in the scene overall, but in the object's reference space.</p>

<p>The third section creates the new {{domxref("XRRigidTransform")}}, specifying a point providing the offsets along the three axes as the first parameter, and the orientation quaternion as the second parameter. The returned object's {{domxref("XRRigidTransform.matrix", "matrix")}} property is the actual matrix that transforms points from the scene's reference space to the object's new position.</p>

<p>Finally, a new reference space is created to describe the relationship between the two reference spaces fully. That reference space is returnedto the caller.</p>

<p>To use this function, we pass the returned reference space into {{domxref("XRFrame.getPose()")}} or {{domxref("XRFrame.getViewerPose", "getViewerPose()")}}, as appropriate for yoru needs. the {{domxref("XRPose")}} returned will then be used to actuall render the scene for the current frame.</p>

<p>You can find a more extensive and complete example in our article <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrview-interface","XRView")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRView")}}</div>
